%ext kdr

#################################
#Files				#
#################################

#Files
%egahead EGAHEAD.KDR
%patchfile $1FA50 "MAPHEAD.CK7"
%patchfile $1FC46 MartGold.tli	#New tile properties
%patchfile $22880 AUDIOHED.AUD	#Audio header

#Screen:
%patchfile $124B1 "KDREAMS.DAT"	#Screen code
%patchfile $32AD0 "KDREAMS.SCT"	#Screen text

#Ignore START.EXE
%patch $3BD1 $EB

%patch $B7DD  $2809W #Text called from
%patch $26279 "KDREAMS.EGA" $00

#Ignore LOADSCN.EXE, never display error message
%patch $39C0 $B8 $0001W  $50 $9A $000004CARL    $44 $44 $5E $5D $CB

#Keen Dreams - remove Huffman compression (Free $B4B5-$B5BF)
%patch $B497  $55 $8B $EC $56 $57 $8C $DA $C4 $7E $0A $C5 $76 $06 $8B $4E $0E $D1
              $E9 $FC $F3 $A5 $73 $01 $A4 $8E $DA $5F $5E  $5D $CB

#Disable help menu point
%patch $28B28 $0000W #Help (At $285C4)

#Disable calling help from the game
%patch $454C $90 #F1 to-
%patch $4553 $41 #F7
%patch $455A $01 #Esc

################
#Worldmap stuff#
################

#Keen starts game in the first level
%patch $3C0C $7124W $0001W

#Keen goes to the next level instead of the map -max level is level 16
%patch $5DF9 $83 $3E $7124W  $10 $73 $26 $FF $06 $7124W  $B8 $000BW  $50 $9A
             $10BB1282RL $44 $44 $EB $1B

#################################
#Death window patch		#
#################################

#Remove 'Exit' text
%patch $5A49 $EB $09

#Move 'try' text down to center
%patch $5A28 $0E

#No rectangle -Keen Dreams
%patch $5A85 $E9 $00EAW

#Any key causes level to reload (Free 5B87-5CF7)
%patch $5B77 $9A $0FE40C8ERL     $9A $0FE40705RL     $5F $5E $8B $E5 $5D $CB

#Didn't make it past window size
%patch $59F4 $0001W #Window height
%patch $59F8 $0014W #Window width

#Exit texts removed
%patch $24589 $00
%patch $24593 $00

#How far from window top 'Didn't make it' text is
%patch $5A07 $00

#How far down second option is from first
%patch $5A40 $00

#Didn't make it past text
%patch $24571 "   Failed! Try again.  " $00

#No level names in window
%patch $5A13 $EB $0F


#################################
#THE BIG ANIMATION SWITCH PATCH	#
#################################

#Skip LZH compression (Free $A634-$A7DE)
%patch $9BA0 $90 $90 $90 $90 $90
%patch $9BF5 $90 $90 $90 $90 $90
%patch $A0B2 $90 $90 $90 $90 $90 #Title

#First minimize the number of animations needed
%patch $24BDC $0000W $0000W #Crouch_2?
%patch $24ECA $0000W $0000W #Throw l\r_4
%patch $24F24 $0000W $0000W #Throw u_3
%patch $25032 $0000W $0000W #Jump-throw l\r_4
%patch $2508C $0000W $0000W #Jump-throw u_3
%patch $250E6 $0000W $0000W #Jump-throw d_3

#Keen's cache hold only the scorebox and door (Emergency measure)
%patch $23E74 $00D3W #Keen cache start
%patch $23EA0 $00D4W #Keen cache end

#Map Keen's cache now loads in all levels, THIS is tweaked
%patch $23E76 $0048W #Map Keen cache start
%patch $23EA2 $0101W #Map Keen cache end

#Eliminate the default cache
%patch $3AFA $00D3W #Keen cache start 1
%patch $3B59 $00D3W #Keen cache start 2

#Change pointers to call the right stuff
%patch $49DF $02ABW #Keen right (At $477B)
%patch $49E1 $02C6W #Keening (At $4796)
%patch $49E3 $02CDW #Marting (At $479D)

#Compact Keen spawn r\l, calls reset code
%patch $4776 $B8 $0001W  $EB $03 $B8 $FFFFW  $50 $FF $36 $7052W  $FF $36 $7050W
                 $9A $05E80CFFRL     $83 $C4 $06 $9A $07C507DCRL     $EB $0C

#Activator inits- call either code and exit
%patch $4796 $9A $0A100534RL     $EB $05  $9A $059A01E7RL     $E9 $0227W

#Items reset code (Set Keen cache, clear Keys and shots on level up =$07C507DCRL
%patch $842C $55 $8B $EC $56 $8B $76 $06 $C7 $06 $711CW  $0000W  $C7 $06 $70BAW
                 $0001W  $C7 $06 $7122W  $0000W  $5E $5D $CB

#Keening code ($A634-$A7DE): Sets default animations =$0A100534RL
%patch $A634 $55 $8B $EC $56 $B8 $0050W  $A3 $0ED8W  $B8 $0048W  $A3 $0EDAW	#Stand
             $B8 $005FW  $A3 $1130W  $B8 $0058W  $A3 $1132W  $B8 $006BW  $A3	#Up, crouch
             $114EW  $B8 $006AW  $A3 $1150W  $B8 $0051W  $A3 $1388W  $B8 $0049W
                 $A3 $138AW  $B8 $0052W  $A3 $13A6W  $B8 $004AW  $A3 $13A8W	#Walk
             $B8 $0053W  $A3 $13C4W  $B8 $004BW  $A3 $13C6W  $B8 $0054W  $A3
             $13E2W  $B8 $004CW  $A3 $13E4W  $B8 $006CW  $A3 $1400W  $B8 $0075W
                 $A3 $1402W  $B8 $006DW  $A3 $141EW  $B8 $0076W  $A3 $1420W	#Shoot l\r, up
             $B8 $006EW  $A3 $143CW  $B8 $0077W  $A3 $143EW  $B8 $006FW  $A3
             $1478W  $A3 $147AW  $B8 $0070W  $A3 $1496W  $A3 $1498W  $B8 $0064W
             $A3 $14D2W  $A3 $150EW  $B8 $005DW  $A3 $14D4W  $A3 $1510W  $B8
             $0065W  $A3 $14F0W  $B8 $005EW  $A3 $14F2W  $B8 $0055W  $A3 $152CW
             $B8 $004DW  $A3 $152EW  $B8 $0056W  $A3 $154AW  $B8 $004EW  $A3	#Jumps
             $154CW  $B8 $0057W  $A3 $1568W  $B8 $004FW  $A3 $156AW  $B8 $007BW
             $A3 $1586W  $B8 $0081W  $A3 $1588W  $B8 $007CW  $A3 $15A4W  $B8
             $0082W  $A3 $15A6W  $B8 $007DW  $A3 $15E0W  $B8 $0083W  $A3 $15E2W
%patch $A728 $B8 $007EW  $A3 $15FEW  $B8 $0084W  $A3 $1600W  $B8 $007FW  $A3
             $163AW  $B8 $0085W  $A3 $163CW  $B8 $0080W  $A3 $1658W  $B8 $0086W
             $A3 $165AW  $B8 $0048W  $A3 $0406W  $B8 $00D4W  $A3 $0432W		#Cache
             $B8 $00A2W  $A3 $19B8W  $A3 $0CFEW  $A3 $0D00W  $B8 $00C3W  $A3	#Shots, Unnapping
             $19BAW  $B8 $00A1W  $A3 $10B8W  $B8 $009CW  $A3 $10BAW  $B8 $00B8W #Items
             $A3 $19B4W  $B8 $10D6W  $A3 $1A54W  $B8 $00BAW  $A3 $19B6W		#Deathact
             $33 $C0 $A3 $7112W  $9A $11FA2E9ARL     $5E $5D $CB		#Set Martvar=0, itswitch

#Marting code (Sets sprites to Marts) = $059A01E7RL
%patch $5B87 $55 $8B $EC $56 $B8 $00D9W  $A3 $0ED8W  $B8 $00D5W  $A3 $0EDAW	#Stand
             $B8 $00EAW  $A3 $1130W  $A3 $1132W  $B8 $00E9W  $A3		#Up, crouch (-1)
             $114EW  $A3 $1150W  $B8 $00DAW  $A3 $1388W  $B8 $00D6W
                 $A3 $138AW  $B8 $00DBW  $A3 $13A6W  $B8 $00D7W  $A3 $13A8W  #Walk
             $B8 $00DCW  $A3 $13C4W  $B8 $00D8W  $A3 $13C6W  $B8 $00F4W  $A3
             $13E2W  $B8 $00F3W  $A3 $13E4W  $B8 $00DCW  $A3 $13C4W  $B8 $00D8W  $A3  
             $13C6W  $B8 $00EFW  $A3 $1400W  $A3 $141EW  $A3 $143CW  $B8 $00F0W	#Throw l\r (-2 frames)
             $A3 $1402W  $A3 $1420W  $A3 $143EW  $B8 $00EDW  $A3
             $1478W  $A3 $147AW  $A3 $1496W  $A3 $1498W  $B8 $00E1W $A3 $154AW	#Throw u (-2 anim)
             $A3 $14D2W  $A3 $150EW  $B8 $00DEW  $A3 $154CW  $A3 $14D4W  $A3
             $1510W  $B8 $00E2W  $A3 $14F0W  $A3 $1568W  $B8 $00DFW  $A3 $156AW	#Fall-jump (-2 frames)
             $A3 $14F2W  $B8 $00E0W  $A3 $152CW  $B8 $00DDW  $A3 $152EW  $B8 $00E3W
             $A3 $1586W  $A3 $15A4W  $B8 $00E4W  $A3 $1588W  $A3 $15A6W  $B8 $00E5W
             $A3 $15E0W  $A3 $15E2W  $A3 $15FEW  $A3 $1600W  $B8 $00EEW  $A3	#Jump-shoot up, down
             $163AW  $A3 $163CW  $A3 $1658W  $A3 $165AW
%patch $5C72 $B8 $00A2W  $A3 $0406W  $B8 $0101W  $A3 $0432W  $B8 $00F1W  $A3	#Cache, items
             $19B8W  $A3 $0CFEW  $A3 $0D00W  $B8 $00BEW  $A3 $19BAW  $B8 $00E6W  $A3
             $10B8W  $A3 $10BAW  $B8 $00F7W  $A3 $19B4W  $B8 $00BCW  $A3 $19B6W
             $B8 $0DB2W  $A3 $1A54W  $A3 $7112W  $9A $11FA2E9ARL     $5E $5D $CB #Set Martvar=/=0, itswitch

#On loading game run the Mart-Keen check (Removes ending apostrophe)
%patch $15902 $044D0739RL

#Mart-Keen check: Run either Marting or Keening code depending on Martvar (And pause!)
%patch $4C09 $55 $8B $EC $56 $83 $3E $7112W  $00 $74 $07 $9A $059A01E7RL
             $EB $05 $9A $059A01E7RL     $5E $5D $CB

#Two bored lists depending on Mart
%patch $6DCC $83 $3E $7112W  $00 $74 $07 $D1 $E3 $2E $FF $A7 $0FC8W  $D1 $E3
             $2E $FF $A7 $0FD4W

#Compact bored codes for space (Repeating two codes!)
%patch $6DE1 $81 $7C $3E $00C8W  $7E $37 $C7 $44 $1E $0EF6W  $EB $28
%patch $6DEF $81 $7C $3E $012CW  $7E $29 $C7 $44 $1E $0F8CW  $EB $1A
%patch $6DFD $81 $7C $3E $02BCW  $7E $1B $C7 $44 $1E $0F14W  $EB $0C
%patch $6E0B $81 $7C $3E $0190W  $7E $0D $C7 $44 $1E $1A56W		#New Mart uplook
             $C7 $44 $3E $0000W  $FF $44 $40 $5E $5D $CB

#Naps
%patch $6E22 $81 $7C $3E $0190W  $7E $08 $C7 $44 $1E $1040W  $FF $44 $40 $5E $5D $CB
%patch $6E34 $81 $7C $3E $02BCW  $7E $08 $C7 $44 $1E $0D3AW  $FF $44 $40 $5E $5D $CB

#New Mart list
%patch $6E54 $0F61W #At $6DE1
             $0F6FW #At $6DEF
             $0F7DW #At $6DFD
             $0F61W #At $6DE1
             $0F7DW #At $6DFD
             $0FA2W #At $6E22

#Old Mart list (Only 2 items long!)
%patch $6E48 $0F8BW #At $6E0B
             $0FB4W #At $6E34

#Old Mart look up bored sequence =$1A56W
%patch $254C6 $00EAW $00EAW $0003W $0000W $0001W $003CW $0000W $0000W
              $05E80EF9RL   $05E817FCRL   $05E81AE2RL   $0ED8W

#Old Mart sit down sequence (1 go, 2 loop) =$0D3AW
%patch $247AA $00E6W $00E6W $0003W $0000W $0001W $0020W $0000W $0000W
              $05E8103CRL   $05E817FCRL   $05E81AE2RL   $0D58W
%patch $247C8 $00E7W $00E7W $0003W $0000W $0001W $0178W $0000W $0000W
              $05E8103CRL   $05E817FCRL   $05E81AE2RL   $0D76W
%patch $247E6 $00E8W $00E8W $0003W $0000W $0001W $0010W $0000W $0000W
              $05E8103CRL   $05E817FCRL   $05E81AE2RL   $0D58W

#Landed seeds always become seeds
%patch $6932 $EB $2F

#Use the bomb in scorebox when Old Mart is in use
%patch $6192 $7112W  $00 $75 #Show bomb count in scorebox
%patch $6198 $1C

#Change scorebox when Old Mart is playing (D4 vs $A9)
%patch $5EBE $55 $8B $EC $83 $EC $06 $56 $57 $83 $3E $7112W  $00 $74 $05 $A1
             $915EW  $EB $03 $A1 $9160W  $A3 $91B4W  $89 $46 $FE $8E $46
             $FE $26 $8B $36 $0020W  $26 $8B $3E $0010W  $A1 $91B4W  $33 $D2
             $26 $03 $16 $00 $00 $03 $D7 $8B $DE $B1 $04 $D3 $E3 $03 $D3 $83
             $C2 $04 $89 $46 $FC $89 $56 $FA $5F $5E $8B $E5 $5D $CB

#Mart shoots green seeds when Old- and seeds aren't bomb-type
%patch $6461 $7112W  $00 $75
%patch $647D $08

#Use, decrease bomb counter when shooting
%patch $6378 $8F3EW $0F $EB

#Thrown Bombs now green seeds
%patch $2467E $00F1W $00F1W
%patch $24688 $000AW
%patch $2469C $00F2W $00F2W
%patch $246A6 $000AW

#On dying Keen goes to decider action
%patch $766C $1A38W

#First death action, depending on Martvar change behavior (Unused 'lash action) =$1A38W
%patch $254A8 $0000W $0000W $0000W $0000W $0000W $0001W $0000W $0000W
              $00000000L    $00000000L    $00000000L    $0DB2W

#Old death behavior; noclip, bounce up =$05E8008BRL
%patch $5F0B $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $44 $18 $FFD0W  
             $C7 $44 $06 $0000W  $C7 $44 $16 $00000W  $5E $5D $CB

#Old Mart death (2 frames, fall, end level) =$1AB0W
%patch $24822 $0000W $0000W $0000W $0000W $0000W $0001W $0000W $0000W #Bounce
              $05E8008BRL   $00000000L    $05E81ABARL   $1AB0W
%patch $25520 $00EBW $00EBW $0003W $0000W $0000W $0024W $0000W $0000W #Fall 1
              $07C501A4RL   $00000000L    $05E81ABARL   $1ACEW
%patch $2553E $00ECW $00ECW $0003W $0000W $0000W $0024W $0000W $0000W #Fall 2
              $07C501A4RL   $00000000L    $05E81ABARL   $0D94W
%patch $24804 $0000W $0000W $0000W $0000W $0000W $0001W $0000W $0000W #Trigger level end
              $05E81079RL   $00000000L    $05E81ABARL   $0D94W

#1UP has two different got sprites depending on Martness (Perfect fit!)
%patch $76E5 $83 $3E $7112W  $00 $75 $07 $C7 $44 $20 $00CDW  $EB $05 $C7 $44
             $20 $00F6W  $FF $06 $7126W  $B8 $0012W  $50 $9A $10BB1282RL
             $44 $44 $EB $49

#Eye item ditto (Perfect fit!)
%patch $7709 $83 $3E $7112W  $00 $75 $07 $C7 $44 $20 $00CEW  $EB $05 $C7 $44
             $20 $00F5W  $83 $06 $7126W  $03 $83 $06 $711CW  $08 $B8 $2710W
             $50 $9A $044D090ERL     $44 $44 $B8 $0012W  $50 $9A $10BB1282RL
                 $44 $44 $EB $14

#Flower Pot code: Different got anim if Old Mart (Perfect fit!)
%patch $7762 $83 $3E $7112W  $00 $74 $07 $C7 $44 $20 $00D0W  $EB $05 $C7 $44
             $20 $00A8W  $83 $06 $711CW  $05 $B8 $0006W  $50 $9A $10BB1282RL
                 $44 $44 $EB $CB

#Boobus Bomb is 10K point item (Jumps to key code)
%patch $7787 $C7 $44 $20 $00D1W  $B8 $2710W  $50 $9A $044D090ERL     $44 $44
             $B8 $0007W  $EB $1E

#Three types of key got anims (Unrelated to Mart!) D2, CB, FF
%patch $77AD $A1 $01CBW  $89 $44 $20 $FF $06 $7122W  $B8 $0017W  $50 $9A
             $10BB1282RL     $44 $44 $EB $8E


#Move key pointer
%patch $790C $192DW #Normal Key (At $779C)

#Key got animation =$01CBW
%patch $23C3B $00D2W


#################################
#THE BIG TRIPLE ITEM TYPE PATCH #
#################################

#Change item inits to use moved code
%patch $4A05 $02FEW #100 Pts (At $47CE)
%patch $4A07 $02FEW #200 Pts (At $47CE)
%patch $4A09 $02FEW #500 Pts (At $47CE)
%patch $4A0B $02FEW #1000 Pts (At $47CE)
%patch $4A0D $02FEW #Type 2 key (At $47CE)
%patch $4A0F $02FEW #5000 Pts (At $47CE)
%patch $4A11 $02FEW #1UP (At $47CE)
%patch $4A13 $02FEW #Eye (At $47CE)
%patch $4A15 $02FEW #Flower Power (At $47CE)
%patch $4A17 $02FEW #Flower Pot (At $47CE)
%patch $4A19 $02FEW #20'000 points (At $47CE)
%patch $4A1B $02FEW #Type 1 Key (At $47CE)
%patch $4A1D $0317W #Door (At $47E7)

#Move items inits nearer Door to free space, jumps to Door code
%patch $47CE $A1 $70ACW  $2D $0015W  $50 $FF $36 $7052W  $FF $36 $7050W  $9A
             $07C504A3RL     $83 $C4 $06 $EB $10

#Door initiation code - moved a single byte
%patch $47E7 $FF $36 $7052W  $FF $36 $7050W  $9A $07C50323RL     $83 $C4 $04
             $8B $1E $3E $70 $C7 $47 $02 $0000W  $EB $1F

#Pointers to three kinds of item setter
%patch $49E5 $04FCW #Type 0 (BLANK)
%patch $49E7 $02D5W #Type 1 (At $47A5)
%patch $49E9 $02DDW #Type 2 (At $47AD)

#Item type variable setter (Set to 0, 1 or 2 for later coding, set Minecarft cache)
%patch $47A5 $C7 $06 $7120W  $0001W  $EB $06 $C7 $06 $7120W  $0002W  $C7 $06
             $70C8W  $0001W  $E9 $0210W

#Special items cache (Formerly Minecart)
%patch $23E84 $00FDW #253-
%patch $23EB0 $0115W #-277

#Item switcher code $11FA2E9ARL loads a different initval depending on itvar and sets item animations
%patch $14E3A $55 $8B $EC $56 $83 $3E $7120W  $01 $7C $0C $7F $05 $B8 $0102W
              $EB $08 $B8 $010CW  $EB $03 $B8 $00ACW  $A3 $19A8W  $05 $0002W
              $A3 $19AAW  $05 $0002W  $A3 $19ACW  $05 $0002W  $A3 $19AEW  $05
              $0002W  $A3 $19B2W  $05 $0002W  $83 $3E $7120W  $01 $7C $0C $7F
              $05 $B8 $00B6W  $EB $08 $B8 $00FDW  $EB $03 $B8 $00C5W  $A3 $19BEW
                  $83 $3E $7120W  $01 $7C $0C $7F $05 $B8 $00CBW  $EB $08 $B8 #Change keycard gots
              $00FFW  $EB $03 $B8 $00D2W  $A3 $01CBW  $83 $3E $7120W  $02 $74 #Change Platforms
              $05 $B8 $1DF8W  $EB $03 $B8 $1DDAW  $A3 $01CDW  $5E $5D $CB

#Eye item only has two frames
%patch $814B $EB $03


#################################
#Electro worm			#
#################################

#Spawn electro worm
%patch $4A33 $02ECW #Key (At $47BC)

#Worm init (Normal spawn, jumps to end of Door code)
%patch $47BC $FF $36 $7052W  $FF $36 $7050W  $9A $11FA2E53RL     $83 $C4 $04
             $EB $29

#Worm spawn code =$11FA2E53RL
%patch $14DF3 $55 $8B $EC $33 $C0 $50 $9A $044D01C9RL     $44 $44 $8B $1E $3E
              $70 $C7 $07 $0007W  $C7 $47 $0E $FFFFW  $8B $46 $06 $B1 $08 $D3
              $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05 $00A0W  $89 $47 $0C $8B
              $1E $3E $70 $B8 $21B8W  $50 $FF $36 $3E $70 $9A $044D1212RL
              $83 $C4 $04 $5D $CB

#Worm animation loop = $21B8W (Uses old Apel interacts)
%patch $25C28 $00F9W $00FBW $0000W $0000W $0001W $0009W $0080W $0000W 
              $00000000L    $00000000L    $07C50299RL   $21D6W
%patch $25C46 $00FAW $00FCW $0000W $0000W $0001W $0009W $0080W $0000W 
              $00000000L    $00000000L    $07C50299RL   $21B8W


#################################
#Status window			#
#################################

#Display one of two helmets for lives\next depending on Mart state
%patch $3D0A $B8 $001AW  $83 $3E $7112W  $00 $74 $03 $B8 $0020W  $50 $FF $36 #Lives
             $E9EEW  $FF $36 $E9ECW  $9A $0CA508F8RL     $83 $C4 $06 $B8 $001BW
                 $83 $3E $7112W  $00 $74 $03 $B8 $0021W  $50 $FF $36 $E9EEW
             $A1 $E9ECW  $05 $0008W  $50 $9A $0CA508F8RL     $83 $C4 $06 $83
             $06 $E9ECW  $18 $A1 $7126W  $99 $52 $50 $9A $11FA1973RL     $83
             $C4 $04 $B8 $0385W  $50 $9A $11FA18FARL     $44 $44 $83 $06 $E9D0W
             $32 $83 $2E $E9D4W  $32 $A1 $E9D0W  $A3 $E9ECW  $A1 $E9D2W  $A3 #Next
             $E9EEW  $C6 $06 $7F $3A $0E $B8 $0387W  $50 $9A $11FA18FARL
             $44 $44 $C6 $06 $7F $3A $0F $A1 $E9ECW  $89 $46  $FE $B8 $001AW
             $83 $3E $7112W  $00 $74 $03 $B8 $0020W  $50 $FF $36 $E9EEW  $FF
             $36 $E9ECW  $9A $0CA508F8RL     $83 $C4 $06 $B8 $001BW  $83 $3E
             $7112W  $00 $74 $03 $B8 $0021W  $50 $FF $36 $E9EEW  $A1 $E9ECW
             $05 $0008W  $50 $9A $0CA508F8RL     $83 $C4 $06 $83 $06 $E9ECW  #Next score
             $18 $FF $36 $711AW  $FF $36 $7118W  $9A $11FA1973RL     $83 $C4
             $04 $B8 $0385W  $50 $9A $11FA18FARL     $44 $44 $8B $46 $FE

#Display 1 of 3 kinds of keycard depending on item state
%patch $3DFA $83 $3E $7120W  $01 $7C $0C $7F $05 $B8 $0014W  $EB $08 $B8 $0015W
                 $EB $03 $B8 $0018W  $50 $FF $36 $E9EEW  $FF $36 $E9ECW  $9A
             $0CA508F8RL     $83 $C4 $06 $83 $06 $E9ECW  $18 $A1 $7122W  $99
             $52 $50 $9A $11FA1973RL     $83 $C4 $04 $B8 $0385W  $50 $9A
         $11FA18FARL     $44 $44 $9A $0CA508C0RL     $9A $0FE40C8ERL     $8B $E5 $5D $CB


#################################
#Pea and Pod			#
#################################

#Change Pea cache -less six
%patch $23EBA $0160W

#Pea has a two frame cycle totalling two frames
%patch $25D34 $22C6W
%patch $25D52 $22A8W
%patch $25D18 $0160W $015FW
%patch $25D36 $015FW $0160W

#Change the Pod's spawn height for memory efficiency
%patch $920C $FF30W

#Peapod doesn't spit
%patch $25DA0 $08680B22RL
%patch $25DBE $08680B22RL
%patch $25DDC $08680B22RL
%patch $25DFA $08680B22RL

#################################
#Asparagusto			#
#################################

#Move cache
%patch $23E7E $0161W #Asparagusto cache start
%patch $23EAA $0166W #Asparagusto cache end

#Asparagusto run
%patch $25688 $0161W $0164W
%patch $25692 $000CW        #Animation speed
%patch $256A6 $0162W $0165W
%patch $256B0 $000CW        #Animation speed
%patch $256C4 $0163W $0166W
%patch $256CE $000CW        #Animation speed
%patch $256E2 $0162W $0165W
%patch $256EC $000CW        #Animation speed


#################################
#Door				#
#################################

#Door choosing action has no animation, chooses sit action
%patch $251A2 $00D3W $00D3W $0002W $0000W $0000W $0000W $0000W $0000W
              $03C0024DRL   $07C5036ERL   $07C501DDRL   $0000W

#Opening door's animation doesn't change
%patch $251C0 $0000W $0000W

#Door choose behavior; based on item state switches = $03C0024DRL
%patch $3E4D $55 $8B $EC $83 $EC $08 $56 $57 $8B $76 $06 $83 $3E $7120W  $01
             $7C $0E $7F $07 $C7 $44 $1E $2230W  $EB $0C $C7 $44 $1E $224EW
             $EB $05 $C7 $44 $1E $2212W  $5F $5E $8B $E5 $5D $CB

#Three Door sit actions (Use old Apel $2212W, $2230W, $224EW)
%patch $25C82 $00D3W $00D3W $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $07C5036ERL   $07C501DDRL   $2212W
%patch $25CA0 $0101W $0101W $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $07C5036ERL   $07C501DDRL   $2230W
%patch $25CBE $0100W $0100W $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $07C5036ERL   $07C501DDRL   $224EW


#################################
#Grape-Green sphere		#
#################################

#Cache - move animations
%patch $23E80 $0121W #Grape cache start
%patch $23EAC $0122W #Grape cache end

#Grape wait - now two actions (Use old Apel $219AW)
%patch $25700 $0121W $0121W $0003W $0000W $0000W $0010W $0000W $0000W
              $07C50917RL   $00000000L    $07C501DDRL   $219AW
%patch $25C0A $0122W $0122W $0003W $0000W $0000W $0010W $0000W $0000W
              $07C50917RL   $00000000L    $07C501DDRL   $1C90W

#Grape fall -two frames (Use old Apel $21F4W)
%patch $2571E $0122W $0122W $0003W $0000W $0000W $0008W $0000W $0000W
              $07C501A4RL   $00000000L    $07C509DERL   $21F4W
%patch $25C64 $0121W $0121W $0003W $0000W $0000W $0008W $0000W $0000W
              $07C501A4RL   $00000000L    $07C509DERL   $1CAEW

#Grape rise
%patch $2573C $0121W $0121W

#Grape stop
%patch $2575A $0121W $0121W


#################################
#Broccolash-robot		#
#################################

#Broccolash spawn height
%patch $81BB $FF60W #10 pixels upwards

#Cache moved to Apel's old location (+84)
%patch $23E78 $0149W #Broccolash cache start
%patch $23EA4 $0154W #Broccolash cache end

#Swap around animations to compact cache (F5,F6->F3,F4 \ FD,FE->F1,F2)
%patch $25430 $0149W $014DW
%patch $2544E $014AW $014EW

#Tank has only two frames walking
%patch $2546A $19C0W

#Move attacking animations up
%patch $254E4 $014BW $0153W
%patch $25502 $014CW $0154W

#Broccolash uses only two frames when attacking
%patch $824A  $1A74W
%patch $2551E $19C0W
%patch $25512 $07C50587RL

#Robot moves forward when attacking, makes noise
%patch $254F0 $0060W
%patch $2550E $0060W
%patch $254F4 $05E80AB4RL

#Make a noise =$05E80AB4RL
%patch $6934 $55 $8B $EC $56 $57 $B8 $0010W  $50 $9A $10BB1282RL     $44 $44
             $5F $5E $5D $CB

#Change attack range
%patch $8216 $FF00W
%patch $8237 $0100W

#Change unused Carrot action to falling worm
#%patch $2566A $00F9W $00FBW

#Landing worm goes to moving
#%patch $84BD $21B8W


#################################
#Apel-bot			#
#################################

#Apel has only four frames of animation
%patch $25BEA $217CW
%patch $25C08 $215EW

#Apel just walk back and forth
%patch $25BDE $00000000L
%patch $25BFC $00000000L

#Apel spawn height adjusted
%patch $8F6D $0040W #16 pixels upwards

#Change walking animations
%patch $25BCE $0125W $0123W
%patch $25BEC $0126W $0124W

#Change cache
%patch $23E8C $0123W #Apel cache start
%patch $23EB8 $0126W #Apel cache end


#################################
#Cart Platforms			#
#################################

#Carts move in air, not on ground
%patch $87DF $75
%patch $87F2 $75

#Platform speeds
%patch $25856 $000FW #Blue
%patch $25874 $000AW #Red

#Change animations -two separate actions
%patch $2584A $00A6W $00A6W #Blue
%patch $25868 $00A7W $00A7W #Red
%patch $25866 $1DDAW
%patch $25884 $1DF8W

#Remove cache (Part of Keen now)
%patch $48DE $E9 $00EBW

#Platform loads changeable action
%patch $87B9 $A1 $01CDW

#Initial action =$01CDW
%patch $23C3D $1DDAW


#################################
#Menu stuff			#
#################################

#Main menu screen background color
%patch $16390 $0000W

#Move texts
%patch $15642 $229ERW #Location of first help text segment
%patch $1564E $22F8RW #Location of second help text segment
%patch $15653 $0006W  #Expand this because someone is a whiner

#Eliminate Joystick configs at $11FA2E52RL
%patch $14DF2 $CB

#Removing joystick menu action
%patch $289BA $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#Removing joystick option completely
%patch $2884E $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#Remove sound source and sound blaster menus
%patch $289EE $0058W $0010W $0078W $0028W $0002W $0013W $001CW $59D2W #No sound
              $0000W $0000W $11FA3C60RL   $0000W
%patch $28A08 $0080W $0010W $00A0W $0028W $0002W $0014W $001DW $59E1W #PC
              $0000W $0000W $11FA3C60RL   $0000W
%patch $28A22 $00A8W $0010W $00C8W $0028W $0002W $0015W $001EW $59F0W #AdLib
              $0000W $0000W $11FA3C60RL   $0000W
%patch $28A3C $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#New start game actions
%patch $28424 $0008W $0004W $0030W $0024W $0002W $0004W $000AW $56AAW #Start game
              $0000W $0000W $11FA2BACRL   $0000W
%patch $2843E $0008W $0024W $0030W $0044W $0002W $0005W $000BW $56C1W #New exit
              $0000W $0000W $11FA3E5ERL   $0000W
%patch $284A6 $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#Load\Save menu actions
%patch $2862C $0088W $0010W $00A8W $0028W $0002W $003FW $0040W $580FW #Load or Save
              $0040W $0000W $11FA3737RL   $0000W
%patch $28646 $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#Choose difficulty menu actions
%patch $28528 $00A8W $0060W $00C8W $0078W $0001W $002DW $002EW $5764W
              $0000W $0000W $11FA3DD0RL   $0000W
%patch $28542 $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W
              $0000W $0000W $00000000L    $0000W


#################################
#Flower and smoke		#
#################################

#Wilted Flowers never recover
%patch $806A $5E $5D $CB

#Smoke has only one frame
%patch $252AE $0000W

#Charred enemies have only two frames
%patch $251FA $178CW
%patch $25218 $178CW

#Change smoke animation
%patch $25292 $00ABW $00ABW

#################################
#Melons				#
#################################

#Horizontal and vertical pips are the same
%patch $8AB4 $208CW

#Vertical pip animations moved
%patch $25AFC $013BW $013CW
%patch $25B1A $013CW $013BW

#Shrink Melon cache to avoid extra frames
%patch $23EB4 $013CW


#################################
#Trooper			#
#################################

#Trooper doesn't attack Keen
%patch $8735 $5F $5E $5D $CB

#Trooper pushes
%patch $791E $1A1FW

#Two frame walking cycle
%patch $25794 $1D26W
%patch $257B2 $1D08W

#Change animations of walking
%patch $25778 $011BW $0119W
%patch $25796 $011CW $011AW

#Change cache to free animations
%patch $23EAE $011CW

#Spawn height adjusted
%patch $86AB $FFFFW


#################################
#Enemy stuff			#
#################################

#Don't display Boobus Bombs message
%patch $4C07 $EB $32

#Don't play King Boobus Tuber death explosion sound
%patch $9388 $EB $09

#Frenchy Chip kills enemies
%patch $88CE  $02
%patch $65D2  $073EW
%patch $259E4 $05E806C7RL
%patch $25A02 $05E806C7RL

#Match sprite type -Pea Pod
%patch $917C $0006W


#################################
#Tomatooth-ball			#
#################################

#Tomatooth has 4 frames of animation (Use two carrot frames)
%patch $255B6 $011DW $0120W $0003W $0000W $0000W $0014W $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1B64W
%patch $255D4 $011EW $011FW $0003W $0000W $0000W $0014W $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1BBEW
%patch $2562E $011FW $011EW $0003W $0000W $0000W $0014W $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1BDCW
%patch $2564C $0120W $011DW $0003W $0000W $0000W $0014W $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1B46W

#Change cache
%patch $23E7A $011DW #Tomatooth cache start
%patch $23EA6 $0120W #Tomatooth cache end


#################################
#Carrot				#
#################################

#Carrot spawn height -level with ground
%patch $8401 $90 $90 $90

#Change cache
%patch $23E7C $013DW #Carrot cache start
%patch $23EA8 $0140W #Carrot cache end

#Carrot run- adjust speed and animations
%patch $255F2 $013DW $013FW
%patch $255FC $0009W        #Animation speed
%patch $25610 $013EW $0140W
%patch $2561A $0009W        #Animation speed

#Carrot doesn't jump at platform edges
%patch $2560A $07C50299RL
%patch $25628 $07C50299RL

#2 frame running animation
%patch $2562C $1B82W


#Items cheat doesn't affect bombs
%patch $382D $EB $04

#Levels F10 + W accesses -Keen Dreams
%patch $3978 $10

#Warp text
%patch $23B7F " Warp to which level (1-16):" $00

#Game over text
%patch $23DDC " YOU LOSE!" $00

#Sound when starting new game
%patch $3C10 $B8 $000BW $50 $9A $10BB1282RL $44 $44 $90

#Boobus stuns normally
%patch $65E6 $06E3W

#Disable 'Press any key' text
%patch $1384A $EB $14

#Ending sequence has only one window
%patch $5956 $CB
%patch $5918 $0002W #Window height (21 chars)
%patch $591C $000CW #Window width (30 chars)
%patch $24128 "YOU WIN!" $00

#Level names are light blue
%patch $C598 $06

#Titlescreen High Scores screen has black background
%patch $445E $0000W #Color
%patch $4462 $00C8W #Vertical size
%patch $4466 $0140W #Horizontal size

#Game Over High Score screen has black background
%patch $16C0E $0000W #Color
%patch $16C12 $00C8W #Vertical size
%patch $16C16 $0140W #Horizontal size

#Main menu texts
%patch $29131 "       Exit to MS-DOS       " $00
%patch $2911A "     Start Game       " $00
%patch $2914E "Load or Save Game " $00
%patch $296BD "     Idling...   " $00
%patch $29697 "Please wait..." $00
%patch $29199 "Click the Martinez Button to Start" $00
%patch $291D4 "   Let the Adventure Begin!  " $00

%patch $29623 "Loading: " $00

#Level 1
%patch $23FDE "    Frostian    "

#Level 2
%patch $23FEF "    Cavities   "

#Level 3
%patch $23FFF "   Cold Dome  "

#Level 4
%patch $2400E "Chilly Quarter"

#Level 5
%patch $2401D "Frost Border"

#Level 6
%patch $2402A "Hellion"

#Level 7
%patch $24032 " Chasms  "

#Level 8
%patch $2403C " River "

#Level 9
%patch $24044 " Fiery Cave"

#Level 10
%patch $24050 "Heat Border"

#Level 11
%patch $2405C " Electr."

#Level 12
%patch $24065 "     Local House   "

#Level 13
%patch $24079 "Ceramics"

#Level 14
%patch $24082 "  Workshop  "

#Level 15
%patch $2408F "   Haunting    "

#Level 16
%patch $2409F "     Home     "

%end